download/panel/php_exts/memcached.sh
2024-11-10 02:06:42 +08:00

113 lines
3.8 KiB (Stored with Git LFS)
Bash

#!/bin/bash
export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:$PATH
: '
Copyright (C) 2022 - now HaoZi Technology Co., Ltd.
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published
by the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.
You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <https://www.gnu.org/licenses/>.
'
source <(curl -f -s --connect-timeout 10 --retry 3 https://dl.cdn.haozi.net/panel/public.sh)
if [ $? -ne 0 ]; then
echo "下载 public.sh 失败,请检查网络或稍后重试。"
echo "Download public.sh failed, please check the network or try again later."
exit 1
fi
action=${1}
version=${2}
php_path="${setup_path}/server/php/${version}"
php_memcached_version="3.3.0"
Install() {
# 检查是否已经安装
is_install=$(cat ${php_path}/etc/php.ini | grep '^extension=memcached$')
if [ "${is_install}" != "" ]; then
error "PHP-${version} 已安装 memcached"
fi
# 安装依赖
if [ ${OS} == "rhel" ]; then
dnf makecache -y
dnf install libmemcached-devel libzstd-devel -y
elif [ ${OS} == "debian" ] || [ ${OS} == "ubuntu" ]; then
apt-get update
apt-get install libmemcached-dev libzstd-dev-y
else
error "不支持的操作系统"
fi
if [ "$?" != "0" ]; then
error "安装依赖软件失败"
fi
cd ${php_path}/src/ext
rm -rf memcached
rm -rf php-memcached-${php_memcached_version}.tar.gz
wget -T 60 -t 3 -O php-memcached-${php_memcached_version}.tar.gz ${download_url}/php_exts/php-memcached-${php_memcached_version}.tar.gz
wget -T 20 -t 3 -O php-memcached-${php_memcached_version}.tar.gz.sha256 ${download_url}/php_exts/php-memcached-${php_memcached_version}.tar.gz.sha256
if ! sha256sum --status -c php-memcached-${php_memcached_version}.tar.gz.sha256; then
rm -f php-memcached-${php_memcached_version}.tar.gz
rm -f php-memcached-${php_memcached_version}.tar.gz.sha256
error "PHP-${version} memcached 校验失败"
fi
tar -zxvf php-memcached-${php_memcached_version}.tar.gz
mv php-memcached-${php_memcached_version} memcached
rm -f php-memcached-${php_memcached_version}.tar.gz
rm -f php-memcached-${php_memcached_version}.tar.gz.sha256
cd memcached
${php_path}/bin/phpize
./configure --with-php-config=${php_path}/bin/php-config --enable-memcached-session --enable-memcached-json --enable-memcached-sasl --with-zstd
make
if [ "$?" != "0" ]; then
rm -rf ${php_path}/src/ext/memcached
error "PHP-${version} memcached 编译失败"
fi
make install
if [ "$?" != "0" ]; then
rm -rf ${php_path}/src/ext/memcached
error "PHP-${version} memcached 安装失败"
fi
sed -i '/;panel/a\extension=memcached' ${php_path}/etc/php.ini
# 重载PHP
systemctl reload php-fpm-${version}.service
echo -e $HR
echo "PHP-${version} memcached 安装成功"
}
Uninstall() {
# 检查是否已经安装
is_install=$(cat ${php_path}/etc/php.ini | grep '^extension=memcached$')
if [ "${is_install}" == "" ]; then
error "PHP-${version} 未安装 memcached"
fi
sed -i '/extension=memcached/d' ${php_path}/etc/php.ini
# 重载PHP
systemctl reload php-fpm-${version}.service
echo -e $HR
echo "PHP-${version} memcached 卸载成功"
}
if [ "$action" == 'install' ]; then
Install
fi
if [ "$action" == 'uninstall' ]; then
Uninstall
fi